// MIDIfoCX

#pragma once

#include <MMSystem.h>
#include "Constants.h"
#include "Interface.h"

namespace GuruGuruSmf { namespace Core {

	/// <summary>
	/// foCX̊NX(?)
	/// </summary>
	class DeviceBase
	{
	protected:
		// ZMIDIbZ[W̐`p
		union ShortMessage
		{
			int Value;
			struct{
				byte Status;
				byte Data1;
				byte Data2;
				byte Reserve;
			};
		};
	};
	
namespace WindowsMultimedia {

	/// <summary>
	/// WindowsMultimediãfoCX
	/// </summary>
	class Device : public DeviceBase, public IDevice
	{
	private:
		bool isOpen;
		HMIDIOUT midiOutHandle;

	public:
		Device();	// RXgN^
		~Device();	// fXgN^

		// foCXJĂ邩ǂ
		bool GetIsOpen(){ return isOpen; }

		// foCXJ
		GGSERROR Open(int deviceId);
		
		// foCX
		void Close();
		
		//
		// IDeveice
		//
		
		// MIDIbZ[W𑗐M
		void SendLongMessage(const byte* data, int length);
		
		// ZMIDIbZ[W𑗐M
		void SendShortMessage(int status, int data1, int data2);
	};


}

namespace DirectMusicPort {

	/// <summary>
	/// DirectMusic Port̃foCX
	/// </summary>
	class Device : public DeviceBase, public IDevice
	{
	private:
		bool isOpen;
		IDirectMusicTimer* times;

	public:
		Device(IDirectMusicTimer* timer);	// RXgN^
		~Device();	// fXgN^

		// foCXJĂ邩ǂ
		bool GetIsOpen(){ return isOpen; }
		
		// foCXJ
		GGSERROR Open(int deviceId, HWND handle);
		
		// foCX
		void Close();
		
		//
		// IDeveice
		//
		
		// MIDIbZ[W𑗐M
		void SendLongMessage(const byte* data, int length);
		
		// ZMIDIbZ[W𑗐M
		void SendShortMessage(int status, int data1, int data2);
		
	};


}

}}



