// vC[̊NX

#pragma once

#include "Interface.h"
#include "SmfController.h"

namespace GuruGuruSmf { namespace Core { namespace Player {

	/// <summary>
	/// GGSCodeCxgsp̊NX(Playergp)
	/// </summary>
	class CodeEventExecutor
	{
	public:
		// sI
		virtual void Execute(CodeEvent* codeEvent, IPlayerCore* core) = 0;
	};
	
	/// <summary>
	/// sȂp
	/// </summary>
	class NullEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core){}
	};

	/// <summary>
	/// I_p
	/// </summary>
	class MusicEndEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// f^^Cp
	/// </summary>
	class DeltaTimeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// e|p
	/// </summary>
	class TempoEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: m[gIp
	/// </summary>
	class PlayingNoteOnEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: m[gItp
	/// </summary>
	class PlayingNoteOffEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: vO`FWp
	/// </summary>
	class PlayingProgramChangeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: Rg[`FWp
	/// </summary>
	class PlayingControlChangeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: {[p
	/// </summary>
	class PlayingVolumeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: sb`xhp
	/// </summary>
	class PlayingPitchBendEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: `lvbV[p
	/// </summary>
	class PlayingCAfEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: |tHjbNL[vbV[p
	/// </summary>
	class PlayingPAfEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Play: GNXN[Vup
	/// </summary>
	class PlayingExclusiveEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	
	
	/// <summary>
	/// Seek: vO`FWp
	/// </summary>
	class SeekingProgramChangeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Seek: Rg[`FWp
	/// </summary>
	class SeekingControlChangeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Seek: {[p
	/// </summary>
	class SeekingVolumeEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Seek: sb`xhp
	/// </summary>
	class SeekingPitchBendEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Seek: `lvbV[p
	/// </summary>
	class SeekingCAfEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};
	
	/// <summary>
	/// Seek: |tHjbNL[vbV[p
	/// </summary>
	class SeekingPAfEventExecutor : public CodeEventExecutor
	{
	public:
		void Execute(CodeEvent* codeEvent, IPlayerCore* core);
	};


	/// <summary>
	/// vC[̊NX
	/// </summary>
	class PlayerBase
	{
	private:
		CodeEventExecutor** playingEventExecutors;
		CodeEventExecutor** seekingEventExecutors;
		
		Smf* smf;
		GgsCode* code;
		
		int keyShift;
		int* pitches;
		bool* rhythmChannels;
		
		int masterPitch;
		
		bool doLoop, doSkipBeginning, doSkipEnding;
		bool doNormalize, canDoMasterPitch, doSendExclusive;

	protected:
		// SMFIuWFNg
		Smf* GetSmf(){ return smf; }
		
		// CodeIuWFNg
		GgsCode* GetCode(){ return code; }
		
		// [v邩ǂ
		bool GetDoLoop(){ return doLoop; }
		
		// `̋󔒂XLbv邩ǂ
		bool GetDoSkipBeginning(){ return doSkipBeginning; }
		
		// ̋󔒂XLbv邩ǂ
		bool GetDoSkipEnding(){ return doSkipEnding; }
		
		// }X^[sb`Lɂ邩ǂ
		bool GetCanDoMasterPitch(){ return canDoMasterPitch; }
		
		// m[}CY邩ǂ
		bool GetDoNormalize(){ return doNormalize; }
		
		// }X^[sb`
		void SetMasterPitchBase(int pitch){ masterPitch = pitch; }
		
		// L[Vtg
		void SetKeyShift(int key){ keyShift = key; }
		
		// Vtgꂽm[gԍ擾
		int GetShiftedNoteBase(int note, int channel);
		
		// }X^[sb`𑗐M
		void SendMasterPitchBase(IDevice* device);
		
		// sb`xhbZ[W𑗐M
		void SendPitchBendBase(IDevice* device, int channel, int pitch);
		
		// GNXN[Vu𑗐M
		void SendExclusiveBase(IDevice* device, CodeEvent* codeEvent);

		// sb`xhZVreB
		void InitializePitchBendSensitivity(IDevice* device);
		
		// SMFŏ
		virtual void Initialize(Smf* newSmf);
		
		// `֊߂
		virtual void Rewind();
		
		// PlayOption
		void ParsePlayOption(int option);
		
		// Cxgs(Play)
		void PlayingEventExecute(CodeEvent* ev, IPlayerCore* core);
		
		// Cxgs(Seek)
		void SeekingEventExecute(CodeEvent* ev, IPlayerCore* core);
		
		// CxgsIuWFNg̔z쐬(Play)
		void MakePlayCodeEventExcutors();
		
		// CxgsIuWFNg̔z쐬(Seek)
		void MakeSeekCodeEventExcutors();
		
	public:
		PlayerBase();	// RXgN^
		virtual ~PlayerBase();	// fXgN^
	};

}}}

