
#include "stdafx.h"
#include "SmfInterpreter.h"

namespace GuruGuruSmf { namespace Core {
	
	// RXgN^
	SmfInterpreter::SmfInterpreter()
	{
		trackData = 0;
	}
	
	// fXgN^
	SmfInterpreter::~SmfInterpreter()
	{
		delete[] trackData;
	}
	
	// SgbNōŏTick擾BIĂ-1Ԃ
	int SmfInterpreter::GetMinTick()
	{
		int tick = Constant::MaxTick;
		
		for (int i=0; i<trackCount; i++){
			TrackData& trk = trackData[i];
			if (trk.State == TrackState::End) continue;
			
			if (tick > trk.Tick) tick = trk.Tick;
		}
		
		if (tick < Constant::MaxTick){
			return tick;
		}else{
			return -1;	// MaxTickȏ̏ꍇłI
		}
	}
	
	// wSMFŏ
	void SmfInterpreter::Initialize(Smf* newSmf)
	{
		smf = newSmf;
		
		trackCount = smf->GetTrackCount();
		trackData = new TrackData[trackCount];
		for (int i=0; i<trackCount; i++){
			TrackData& trk = trackData[i];
			trk.SmfTrack = smf->GetTrack(i);
		}
		
		Rewind();
	}
	
	// ŏ܂Ŋ߂
	void SmfInterpreter::Rewind()
	{
		smf->Rewind();
		
		for (int i=0; i<trackCount; i++){
			TrackData& trk = trackData[i];
			
			// ŏ̃f^^C擾
			GGSERROR err;
			trk.Tick = trk.SmfTrack->ReadDeltaTime(err);
			
			if (err == GgsError::NoError){
				trk.State = TrackState::Play;
			}else{
				trk.State = TrackState::End;
			}
		}
		
	}
	
	// Cxg߂ď
	GGSERROR SmfInterpreter::InterpretSmf()
	{
		while(1){
			int tick = GetMinTick();
			if (tick < 0) break;
			UpdateTick(tick);
			
			for (int i=0; i<trackCount; i++){
				TrackData& trk = trackData[i];
				if (trk.State == TrackState::End) continue;
				
				while (tick >= trk.Tick){
					GGSERROR err;
					SmfEvent* smfEvent = trk.SmfTrack->ReadSmfEvent(err);
					if (err == GgsError::TrackLimit || smfEvent->Type == SmfEventType::TrackEnd){
						trk.State = TrackState::End;
						break;
					}
					if (err != GgsError::NoError) return err;

					EventExecute(smfEvent);
					trk.Tick += smfEvent->DeltaTime;
				}
			}
		}
		return GgsError::NoError;
	}
	
	
	
}}


